#ifndef VISIT_H
#define VISIT_H

#include"lock.h"

#ifndef PTHREADS_MAX
#define PTHREADS_MAX (64)
#endif

#define VISIT_NODE_MAX (PTHREADS_MAX * 2)

struct visit_thread {
	pthread_t thread;
	struct visit_thread *next;
};

union visit_thread_node {
	struct visit_thread thread;
	union visit_thread_node *next;
};

struct visit_thread_pool {
	struct visit_thread_node base[VISIT_NODE_MAX], *avail;
	lock_t free;
};

struct visit {
	void *node;
	struct visit_queue {
		struct visit_thread *front, *rear;
	} queue;
};

union visit_node {
	struct visit visit;
	union visit_node *next;
};

struct visit_node_pool {
	union visit_node base[VISIT_NODE_MAX], *avail;
	lock_t free;
};

struct visit_entry {
	lock_t lock;
	struct visit *visit;
	struct visit_entry *left, *right;
};

struct visit_table {
	struct visit_entry base[VISIT_NODE_MAX], *root;
	struct visit_pool {
		struct visit_node_pool visit;
		struct visit_thread_pool thread;
	} pool;
};
#define VISIT_TABLE_SIZE (sizeof(struct visit_table))

#ifndef VISIT_T
#define VISIT_T
typedef const struct visit_table * const visit_t;
#endif

visit_t visit_new();
void visit_dispose(visit_t visit);

void visit(visit_t visit, void *node);
void farewell(visit_t visit, void *node);

#endif
