#ifndef CACHE_H
#define CACHE_H

#include"lock.h"
#include"mutex.h"

#include"file.h"
#include"fs.h"

struct block {
	lock_t lock;
	bool_t write;
	long address;
	void *ptr;
	struct file *file;
	list_ptr_t ptr;
};

struct block_pool {
	struct block_node *base, *avail;
	lock_t free;
};

union cache_base {
	void *memory;
	struct file *file;
};

struct cache {
	int size;
	struct fs *fs;
	union cache_base base;
	struct block_pool pool;
	list_t list;
	table_t table;
};

void *cache_read(struct cache *cache, long address, void *buffer);
struct cache *cache_write(struct cache *cache, long address, void *buffer);

#endif
