#ifndef COND_H
#define COND_H

/* Author : sundaresh venugopal */

#include<time.h>

#include"mutex.h"

#ifndef EACTIVE
#define EACTIVE
#endif

#ifndef PTHREAD_COND_T
#define PTHREAD_COND_T
typedef struct condition {
	short signal, count;
} pthread_cond_t;
#endif

#ifndef PTHREAD_CONDATTR_T
#define PTHREAD_CONDATTR_T
typedef int pthread_condattr_t;
#endif

#define PTHREAD_COND_INITIALIZER { 0, 0 }

/* Non standard macro */
#define pthread_cond_active(cond) (((cond)->count > 0) || ((cond)->signal > 0))

int pthread_cond_init(pthread_cond_t *cond, pthread_condattr_t *attr);
int pthread_cond_destroy(pthread_cond_t *cond);
int pthread_cond_timedwait(pthread_cond_t *cond, pthread_mutex_t *mutex, struct timespec *abstime);
#define pthread_cond_wait(cond, mutex) pthread_cond_timedwait(cond, mutex, NULL)
#define pthread_cond_broadcast(cond) ((cond)->signal > 0 ? (cond)->signal = (cond)->count, 0 : 1)
#define pthread_cond_signal(cond) (pthread_cond_active(cond) ? (cond)->signal++, 0 : 1)

#endif
