#ifndef COUNTER_H
#define COUNTER_H

/* Author : sundaresh venugopal */

#include<time.h>

#ifndef EACTIVE
#define EACTIVE
#endif

enum op_type { PARALLEL, SEQUENTIAL };

struct op_counter {
	unsigned up, down;
};

enum counter_type { BALANCED, BIASED_PARALLEL = 1, BIASED_SEQUENTIAL = 3 };

struct balanced_counter {
	struct op_counter parallel, sequential;
};

struct biased_counter {
	unsigned parallel, sequential;
};

#ifndef COUNTER_T
#define COUNTER_T
typedef struct counter {
	unsigned char rwlock : 1;
	unsigned char type : 7;
        union {
		struct balanced_counter balanced;
		struct biased_counter biased;
	} counter;
} counter_t;
#endif

void counter_init(counter_t *counter, int type);
int counter_tryup(counter_t *counter, int op);
int counter_timedup(counter_t *counter, int op, struct timespec *abstime);
#define counter_up(counter, op) (counter_timedup(counter, op, NULL))
int counter_down(counter_t *counter, int op);
int counter_active(counter_t *counter);

#endif
