
#include<pthread.h>

#include"deadlock.h"

int deadlocked(lock_t *lock) {
	/* thread is relative to kernel data space, rest are relative to user data space */
	pthread_t self, thread, sequence[PTHREADS_MAX];
	table_t deadlock;
	int pos, last;

	self = pthread_self();
	thread = list_get(self->list.deadlock, GET_CURRENT, &lock->ptr.deadlock);
	if(! thread) list_insert(self->list.deadlock, lock->thread, &lock->ptr.deadlock);
	if(deadlock = table_create(DEADLOCK_TABLE, PTHREAD_MAX, 0, NULL, NULL)) {
		pos = last = 0;
		sequence[last] = lock->thread;
		table_insert(deadlock, self);
		while(pos <= last) {
			listptr_t ptr;

			thread = list_get(sequence[pos]->process.list.deadlock, GET_FIRST, &ptr);
			while(thread) {
				last++;
				sequence[last] = thread;
				if(! table_insert(deadlock, thread)) {
					table_destroy(deadlock);
					return 1;
				}
				thread = list_get(sequence[pos]->process.list.deadlock, GET_NEXT, &ptr);
			}
			pos++;
		}
		table_destroy(deadlock);
		return 0;
	}
	return -1;
}
