#ifndef LOCK_H
#define LOCK_H

/* Author : sundaresh venugopal */

#include"bool.h"
#include"list.h"

struct pthread;

#ifndef PTHREAD_T
#define PTHREAD_T
/* This pointer is relative to the kernel's data space */
typedef const struct pthread * const pthread_t;
#endif

#ifndef EBUSY
#define EBUSY
#endif

#ifndef EDEADLK
#define EDEADLK
#endif

#ifndef NDEBUG || ! defined NDEADLOCK_CHECK
#define DEADLOCK_CHECK TRUE
#else
#define DEADLOCK_CHECK FALSE
#endif

#define LOCK_LIST_TYPE (LINKED_TYPE + SINGLY_LINKED)

#ifndef LOCK_T
#define LOCK_T
typedef struct lock {
	unsigned short mutex : 1;
	unsigned short lock : 15;
	pthread_t thread;
	struct lock_ptr {
		listptr_t lock, deadlock;
	} ptr;
} lock_t;
#endif

#define DEADLOCK_RETRIES (20)

void lock_init(lock_t *lock);
int trylock(lock_t *lock);
int lock(lock_t *lock);
int unlock(lock_t *lock);

#endif
