#ifndef MUTEX_H
#define MUTEX_H

/* Author : sundaresh venugopal */

#include<stddef.h>

#include"lock.h"

#ifndef NULL
#define NULL ((void *)0)
#endif

#ifndef PTHREAD_PRIORITY_LEVEL
#define PTHREAD_PRIORITY_LEVEL (10)
#endif

/* Default mutex queue length */
#define PTHREAD_MUTEX_QUEUE_LEN (PTHREADS_MAX / 4)

#ifndef PTHREAD_T
#define PTHREAD_T
/* This pointer is relative to the kernel's data space */
typedef const struct pthread * const pthread_t;
#endif

/* This pointer is relative to the user data space */
#ifndef PTHREAD_MUTEX_T
#define PTHREAD_MUTEX_T
typedef struct mutex {
	priority_t ceiling;
	bool_t dead;
	lock_t lock;
	list_t queue;
} pthread_mutex_t;
#endif

#ifndef PTHREAD_MUTEXATTR_T
#define PTHREAD_MUTEXATTR_T
typedef int pthread_mutexattr_t;
#endif

#define PTHREAD_MUTEX_INITIALIZER { FALSE, { 1, 0, NULL, { { NULL, NULL }, { NULL, NULL } }, NULL }
#define PTHREAD_MUTEXATTR_INITIALIZER PTHREAD_MUTEX_QUEUE_LEN

int pthread_mutexattr_getqueuelen(pthread_mutexattr_t *attr, int len);
int pthread_mutexattr_setqueuelen(pthread_mutexattr_t *attr, int len);

int pthread_mutex_init(pthread_mutex_t *mutex, pthread_mutexattr_t *attr);
int pthread_mutex_destroy(pthread_mutex_t *mutex);

int pthread_mutex_trylock(pthread_mutex_t *mutex);
int pthread_mutex_lock(pthread_mutex_t *mutex);
int pthread_mutex_unlock(pthread_mutex_t *mutex);

#endif
