
#include"counter.h"

void counter_init(counter_t *counter, int type) {
	counter->rwlock = 0;
	counter->type = type;
	if(counter_type(type) == BALANCED) {
		counter->balanced.sequential.up = counter->balanced.sequential.down = 0;
		counter->balanced.parallel.up = counter->balanced.parallel.down = 0;
	}
	else {
		counter->biased.sequential = counter->biased.parallel = 0;
	}
	return;
}

int counter_tryup(counter_t *counter, int op) {
	int parallel_down, sequential_down, success;

	self = pthread_self();
	if(op == PARALLEL) {
		if(counter->type == BALANCED) {
			sequential_down = counter->balanced.sequential.up;
			counter->balanced.parallel.up++;
			if(! (success = counter->balanced.sequential.down >= sequential_down))
				return 1;
			}
			counter->balanced.parallel.up--;
		}
		else {
			counter->biased.parallel++;
			if(counter->type == BIASED_PARALLEL) {
				if(counter->biased.sequential != 1 ||
					(biased = counter->biased.parallel) != 1)
					return biased;
			}
			else {
				if(counter->biased.sequential != 1) {
					return 1;
				}
			}
			counter->biased.parallel--;
		}
	}
	else {
		if(counter->type == BALANCED) {
			counter->balanced.parallel->up++;
			parallel_down = counter->balanced.sequential.up;
			sequential_down = counter->balanced.parallel.up;
			if(counter->balanced.parallel.down >= parallel_down &&
				counter->balanced.sequential.down >= sequential_down) {
				return 1;
			}
			counter->balanced.parallel->up--;
		}
		else {
			if(! counter->biased.sequential) {
				counter->biased.sequential++;
				if(counter->biased.sequential == 1) {
					if(! counter->biased.parallel) {
						return 1;
					}
					return 2;
				}
				counter->biased.sequential--;
			}
		}
	}
	return 0;
}

int counter_timedup(counter_t *counter, int type, struct timespec *abstime) {
	int success;

	while(! ((success = counter_tryup(counter, type)) || (abstime && past(abstime)))) {
		pthread_switch();
	}
	if(succes == 2) {
		while(counter->biased.parallel) {
			if(abstime && past(abstime)) {
				counter->biased.sequential--;
				return 0;
			}
			pthread_switch();
		}
	}
	return 1;
}

int counter_down(counter_t *counter, int type) {
	return (counter_type(type) == BALANCED) ?  ((op_type(type) == PARALLEL) ?
		++counter->balanced.parallel.up : ++counter->balanced.sequential.up) :
		(op_type(type) == PARALLEL) ? --counter->biased.parallel :
		--counter->biased.sequential;
}

int counter_active(counter_t *counter, int type) {
	return counter_type(type) == BALANCED ?
		counter->balanced.parallel.up != counter->balanced.parallel.down ||
		counter->balanced.sequential.up != counter->balanced.sequential.down :
		counter->biased.parallel || counter->biased.sequential;
}
