#ifndef DEADLOCK_H
#define DEADLOCK_H

#include<sys/types.h>

#include"counter.h"

#ifndef EDEADLK
#define EDEADLK
#endif

/* These defenitions, & structures are part of the kernel process */

/* These values are arbitrarily defined and may have to be suitably defined */

/* Maximum number of process's allowed by the system */
#ifndef PROCESS_MAX
#define PROCESS_MAX (512)
#endif

/* Maximum number of threads per process */
#ifndef PTHREADS_MAX
#define PTHREADS_MAX (128)
#endif

struct deadlock {
	pthread_t thread;
	struct deadlock *next;
	struct deadlock_usage {
		struct deadlock *previous, *next;
	} used;
};

/* These defenitions, & structures are user process specific */

/* Size of the deadlock pool */
#ifdef BITWISE
#define DEADLOCK_MAX ((PTHREADS_MAX) << (2))
#else
#define DEADLOCK_MAX ((PTHREADS_MAX) * (4))
#endif

/* This pool is common to all threads, of a particular process */
struct deadlock_pool {
	struct deadlock base[DEADLOCK_MAX];
	struct deadlock_pool_used {
		struct deadlock *most, *least;
		lock_t lock;
	} used;
};

/* This structure is for internal use by the deadlocked function alone
 * It is an entry in the table for determining deadlocks */
struct deadlock_entry {
	pthread_t thread;
	struct deadlock_entry *left, *right;
};

int deadlocked(lock_t *lock);

#endif
