#ifndef LOCK_H
#define LOCK_H

#include<asm/atomic.h>

#ifndef PTHREAD_T
#define PTHREAD_T
/* This pointer is relative to the kernel's data space */
typedef const struct pthread * const pthread_t;
#endif

#ifndef EBUSY
#define EBUSY
#endif

#ifndef NDEBUG || ! defined NDEADLOCK_CHECK
#define DEADLOCK_CHECK TRUE
#else
#define DEADLOCK_CHECK FALSE
#endif

#ifndef LOCK_T
#define LOCK_T
typedef struct lock {
	pthread_t thread;
	atomic_t lock;
} lock_t;
#endif

int lock(lock_t *lock);
int unlock(lock_t *lock);

union lock_node {
	lock_t lock;
	union lock_node *next;
};

struct lock_pool {
	union lock_node *base, *avail;
	lock_t free;
	int size;
};

struct lock_pool *lock_pool_create(struct lock_pool *pool, int size);
void lock_pool_destroy(struct lock_pool *pool);

lock_t *lock_obtain(struct lock_pool *pool);
struct lock_pool *lock_return(struct lock_pool *pool, lock_t *lock);

#endif
