#ifndef LOCK_H
#define LOCK_H

#include<asm/atomic.h>

struct pthread;

#ifndef PTHREAD_T
#define PTHREAD_T
/* This pointer is relative to the kernel's data space */
typedef const struct pthread * const pthread_t;
#endif

#ifndef EBUSY
#define EBUSY
#endif

#ifndef EDEADLK
#define EDEADLK
#endif

#ifndef NDEBUG || ! defined NDEADLOCK_CHECK
#define DEADLOCK_CHECK TRUE
#else
#define DEADLOCK_CHECK FALSE
#endif

#ifndef LOCK_T
#define LOCK_T
typedef struct lock {
	pthread_t thread;
	atomic_t lock;
} lock_t;
#endif

#define DEADLOCK_RETRIES (20)

void init_lock(lock_t *lock);
int try_lock(lock_t *lock);
int lock(lock_t *lock);
int unlock(lock_t *lock);

#endif
