#ifndef MUTEX_H
#define MUTEX_H

#include<stddef.h>

#include"lock.h"

#ifndef NULL
#define NULL ((void *)0)
#endif

#ifndef PTHREAD_T
#define PTHREAD_T
/* This pointer is relative to the kernel's data space */
typedef const struct pthread * const pthread_t;
#endif

struct mutex_request {
	pthread_t thread;
	struct mutex_request *next;
};

union mutex_request_node {
	struct mutex_request request;
	union mutex_request_node *next;
};

struct mutex_request_pool {
	union mutex_request_node base[PTHREADS_MAX], *avail;
	lock_t free;
};

#ifndef PTHREAD_MUTEX_T
#define PTHREAD_MUTEX_T
typedef struct mutex {
	lock_t lock;
	struct mutex *previous, *next;
	struct mutex_queue {
		struct mutex_request *front, *rear;
	} queue;
} pthread_mutex_t;
#endif

#define PTHREAD_MUTEX_INITIALIZER { { NULL, 0 }, NULL, NULL , { NULL, NULL } }

int pthread_mutex_trylock(pthread_mutex_t *mutex);
int pthread_mutex_lock(pthread_mutex_t *mutex);
int pthread_mutex_unlock(pthread_mutex_t *mutex);

#endif
